//---------------------------------------------------------------------------
#ifndef App_DocumentH
#define App_DocumentH
//---------------------------------------------------------------------------
#include "App_Common.h"
//---------------------------------------------------------------------------
namespace App_document {
//---------------------------------------------------------------------------
class TDocument : public TModel
{
private:
	AnsiString FFile;
	bool FDereference;
	bool FAutoClose;
	TNotifyEvent FOnFileChange;
	TNotifyEvent FOnDereferenceChange;
	TNotifyEvent FOnAutoCloseChange;
	static AnsiString __fastcall EnsureValidPath(const AnsiString& APath);
	void __fastcall SetFile(const AnsiString& AFile);
	void __fastcall SetDereference(bool ADereference);
	void __fastcall SetAutoClose(bool AAutoClose);
protected:
	virtual void __fastcall DoFileChange();
	virtual void __fastcall DoDereferenceChange();
	virtual void __fastcall DoAutoCloseChange();
public:
	__fastcall TDocument();
	virtual __fastcall ~TDocument();
	virtual AnsiString __fastcall DetermineFile();
	virtual AnsiString __fastcall DetermineTitle();
	virtual void __fastcall DetermineIcon(TIcon* AIcon);
	virtual bool __fastcall IsEmpty();
	virtual bool __fastcall IsShortcut();
	__property AnsiString File = {read=FFile, write=SetFile};
	__property bool Dereference = {read=FDereference, write=SetDereference};
	__property bool AutoClose = {read=FAutoClose, write=SetAutoClose};
	__property TNotifyEvent OnFileChange = {read=FOnFileChange, write=FOnFileChange};
	__property TNotifyEvent OnDereferenceChange = {read=FOnDereferenceChange, write=FOnDereferenceChange};
	__property TNotifyEvent OnAutoCloseChange = {read=FOnAutoCloseChange, write=FOnAutoCloseChange};
};
//---------------------------------------------------------------------------
class TDocumentCommands : public TCommands
{
private:
	TDocument* FDocument;
	static AnsiString __fastcall DetermineCommandPrompt();
	__property TDocument* Document = {read=FDocument};
protected:
public:
	__fastcall TDocumentCommands(TDocument* ADocument);
	virtual __fastcall ~TDocumentCommands();
	virtual void __fastcall Open();
	virtual bool __fastcall CanOpen();
	virtual void __fastcall Explore();
	virtual bool __fastcall CanExplore();
	virtual void __fastcall CopyPath();
	virtual bool __fastcall CanCopyPath();
	virtual void __fastcall StartCommandPrompt();
	virtual bool __fastcall CanStartCommandPrompt();
	virtual void __fastcall ShowProperties();
	virtual bool __fastcall CanShowProperties();
	virtual void __fastcall DropFiles(const TStringDynArray& AFiles);
	virtual bool __fastcall CanDropFiles();
};
//---------------------------------------------------------------------------
} // End namespace App_document
using namespace App_document;
//---------------------------------------------------------------------------
#endif

