//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAppMainForm* AppMainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Execute(TObject* ASender)
{
	DocumentCommands->ShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action121Execute(TObject* ASender)
{
	HelpCommands->OpenHelp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action121Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanOpenHelp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action122Execute(TObject* ASender)
{
	HelpCommands->ShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action122Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Execute(TObject* ASender)
{
	DocumentCommands->Open();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanOpen();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action22Execute(TObject* ASender)
{
	DocumentCommands->Explore();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action22Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanExplore();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Execute(TObject* ASender)
{
	DocumentCommands->CopyPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanCopyPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Execute(TObject* ASender)
{
	DocumentCommands->StartCommandPrompt();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanStartCommandPrompt();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Execute(TBasicAction* AAction, bool& AHandled)
{
	TAction* LAction = static_cast<TAction*>(AAction);
	if(LAction->OnExecute == NULL) {
		return;
	}
	TCursor LCursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try {
		try {
			LAction->OnExecute(LAction);
		}
		catch(...) {
			UpdateNotifier->Invalidate();
			throw;
		}
		UpdateNotifier->Invalidate();
	}
	catch(...) {
		Screen->Cursor = LCursor;
		throw;
	}
	Screen->Cursor = LCursor;
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::CheckBox1Click(TObject* ASender)
{
	TCheckBox* LSender = static_cast<TCheckBox*>(ASender);
	Document->Dereference = LSender->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::CheckBox2Click(TObject* ASender)
{
	TCheckBox* LSender = static_cast<TCheckBox*>(ASender);
	Document->AutoClose = LSender->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Initialize()
{
	try {
		// Set the layout
		{
			int LIconWidth = 16;
			int LIconHeight = 16;
			Image1->BoundsRect = Bounds(
				Image1->Left + (Image1->Width - LIconWidth) / 2,
				Image1->Top + (Image1->Height - LIconHeight) / 2,
				LIconWidth,
				LIconHeight);
		}

		// Create objects
		FDocument = new TDocument();
		FDocumentCommands = new TDocumentCommands(FDocument);
		FHelpCommands = new THelpCommands();
		FUpdateNotifier = new TUpdateNotifier();

		// Connect the objects
		FDocument->OnFileChange = DocumentFileChange;
		FDocument->OnDereferenceChange = DocumentDereferenceChange;
		FDocument->OnAutoCloseChange = DocumentAutoCloseChange;
		FUpdateNotifier->OnUpdate = UpdateNotifierUpdate;

		// Set the default values
		FDocument->OnFileChange(FDocument);
		FDocument->OnDereferenceChange(FDocument);
		FDocument->OnAutoCloseChange(FDocument);
		FUpdateNotifier->Update();

		HandleCommandLineParameters();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Uninitialize()
{
	delete FUpdateNotifier;
	FUpdateNotifier = NULL;

	delete FHelpCommands;
	FHelpCommands = NULL;

	delete FDocumentCommands;
	FDocumentCommands = NULL;

	delete FDocument;
	FDocument = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleCommandLineParameters()
{
	if(ParamCount() == 0) {
		Application->MessageBox(
			"Start the program with a drop of files onto the icon.",
			Application->Title.c_str(),
			MB_OK | MB_ICONINFORMATION | MB_SETFOREGROUND);
		Abort();
	}
	TStringDynArray LFiles;
	LFiles.Length = ParamCount();
	for(int LI = 0; LI < ParamCount(); ++LI) {
		LFiles[LI] = ParamStr(LI + 1);
	}
	DocumentCommands->DropFiles(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TAction* LAction = static_cast<TAction*>(ActionList1->Actions[LI]);
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
	CheckBox1->Enabled = !Document->IsEmpty() && Document->IsShortcut();
	CheckBox2->Enabled = !Document->IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentFileChange(TObject* ASender)
{
	Caption = AnsiString().sprintf(
		"%s - %s",
		Document->DetermineTitle().c_str(),
		TCommon::Title.c_str());
	Document->DetermineIcon(Image1->Picture->Icon);
	Label1->Caption = MinimizeName(Document->File, Label1->Canvas, Label1->ClientWidth);
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentDereferenceChange(TObject* ASender)
{
	CheckBox1->Checked = Document->Dereference;
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentAutoCloseChange(TObject* ASender)
{
	CheckBox2->Checked = Document->AutoClose;
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateNotifierUpdate(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::TAppMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FDocument(NULL),
	FDocumentCommands(NULL),
	FHelpCommands(NULL),
	FUpdateNotifier(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::~TAppMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------

